#ifndef __VECTOR3_BI__
#define __VECTOR3_BI__

type Vector
  x AS single
  y AS single
	z as single
end type

declare sub VAdd (v AS Vector, a AS Vector, b AS Vector)
declare sub VAdd2V (v AS Vector, a AS Vector)
declare sub VAddComp (v AS Vector, a AS Vector, x as single, y as single, z as single)
declare sub VAddComp2V (v AS Vector, x as single, y as single, z as single)
declare sub VAddMul (v AS Vector, k1 as single, a AS Vector, k2 as single, b AS Vector)
declare function VDist (a AS Vector, b AS Vector) as single
declare sub VLimit2V (v AS Vector, d as single)
declare function VMag (v AS Vector) as single
declare sub VNeg (v AS Vector, a AS Vector)
declare sub VNeg2V (v AS Vector)
declare sub VScale (v AS Vector, a AS Vector, k as single)
declare sub VScale2V (v AS Vector, k as single)
declare sub VSet (v AS Vector, x as single, y as single, z as single)
declare sub VSub (v AS Vector, a AS Vector, b AS Vector)
declare sub VSub2V (v AS Vector, a AS Vector)
declare sub VSubComp (v AS Vector, a AS Vector, x as single, y as single, z as single)

declare sub VRot2Vx (v AS Vector, r as single)
declare sub VRot902Vx (v AS Vector)
declare sub VRot2Vy (v AS Vector, r as single)
declare sub VRot902Vy (v AS Vector)
declare sub VRot2Vz (v AS Vector, r as single)
declare sub VRot902Vz (v AS Vector)

declare function VDot(v1 as vector, v2 as vector) as single
#endif
